PIRL.Viewers

## Class Parameter_View

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - java.awt.Window
      - - java.awt.Frame
        - - javax.swing.JFrame
          - - PIRL.Viewers.Parameter_View

All Implemented Interfaces:
  ImageObserver, MenuContainer, Serializable, Accessible, RootPaneContainer, WindowConstants

    public class Parameter_View
    extends JFrame

A Parameter_View provides a graphical view of a Parameter.

The view contains a Parameter_Pane to display the Parameter data.

See Also:
  `Parameter_Pane`, `Parameter`, Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class javax.swing.JFrame

`JFrame.AccessibleJFrame`

### Nested classes/interfaces inherited from class java.awt.Frame

`Frame.AccessibleAWTFrame`

### Nested classes/interfaces inherited from class java.awt.Window

`Window.AccessibleAWTWindow, Window.Type`

### Nested classes/interfaces inherited from class java.awt.Container

`Container.AccessibleAWTContainer`

### Nested classes/interfaces inherited from class java.awt.Component

`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

### Field Summary

### Fields inherited from class javax.swing.JFrame

`accessibleContext, EXIT_ON_CLOSE, rootPane, rootPaneCheckingEnabled`

### Fields inherited from class java.awt.Frame

`CROSSHAIR_CURSOR, DEFAULT_CURSOR, E_RESIZE_CURSOR, HAND_CURSOR, ICONIFIED, MAXIMIZED_BOTH, MAXIMIZED_HORIZ, MAXIMIZED_VERT, MOVE_CURSOR, N_RESIZE_CURSOR, NE_RESIZE_CURSOR, NORMAL, NW_RESIZE_CURSOR, S_RESIZE_CURSOR, SE_RESIZE_CURSOR, SW_RESIZE_CURSOR, TEXT_CURSOR, W_RESIZE_CURSOR, WAIT_CURSOR`

### Fields inherited from class java.awt.Component

`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

### Fields inherited from interface javax.swing.WindowConstants

`DISPOSE_ON_CLOSE, DO_NOTHING_ON_CLOSE, HIDE_ON_CLOSE`

### Fields inherited from interface java.awt.image.ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

### Constructor Summary

Constructors
Constructor and Description
`Parameter_View(Parameter parameter)` Creates a Parameter_View from the specified Parameter and gives it the Parameter's name as the title.
`Parameter_View(String title, Parameter parameter)` Creates a Parameter_View from the specified Parameter.

### Method Summary

Methods
`String` `CWD()` Gets the current working directory for finding parameter files.
`Parameter_View` `CWD(File file)` Sets the current working directory for finding parameter files.
`Parameter_View` `CWD(String pathname)` Sets the current working directory for finding parameter files.
`static void` `main(String[] arguments)` Creates a Parameter_View displaying the Parameters found in each file listed on the command line.
`protected JMenuBar` `Menu_Bar()` Creates a menu bar for the viewer.
`Parameter_Pane` `Parameter_Pane()` Gets the Parameter_Pane used by this Parameter_View.
`Parameter` `Parameter()` Gets the Parameter being viewed by this Parameter_View.
`void` `Parameter(Parameter parameter)` Sets the Parameter to be viewed by this Parameter_View.
`Parameter_View` `Title(String source)` Sets the window title to the filename portion of the name.
`Parameter_View` `Title(URL url)` Sets the window title to the filename portion of the URL.
`JTreeTable` `TreeTable()` Gets the JTreeTable being used to represent the Parameters in the display.
`static boolean` `Use_LAF_Hack()` Tests if the Java (cross platform) Look and Feel is to be used.
`static void` `Use_LAF_Hack(boolean enable)` Enables or disables the Java (cross platform) Look and Feel hack.

### Methods inherited from class javax.swing.JFrame

`addImpl, createRootPane, frameInit, getAccessibleContext, getContentPane, getDefaultCloseOperation, getGlassPane, getGraphics, getJMenuBar, getLayeredPane, getRootPane, getTransferHandler, isDefaultLookAndFeelDecorated, isRootPaneCheckingEnabled, paramString, processWindowEvent, remove, repaint, setContentPane, setDefaultCloseOperation, setDefaultLookAndFeelDecorated, setGlassPane, setIconImage, setJMenuBar, setLayeredPane, setLayout, setRootPane, setRootPaneCheckingEnabled, setTransferHandler, update`

### Methods inherited from class java.awt.Frame

`addNotify, getCursorType, getExtendedState, getFrames, getIconImage, getMaximizedBounds, getMenuBar, getState, getTitle, isResizable, isUndecorated, remove, removeNotify, setBackground, setCursor, setExtendedState, setMaximizedBounds, setMenuBar, setOpacity, setResizable, setShape, setState, setTitle, setUndecorated`

### Methods inherited from class java.awt.Window

`addPropertyChangeListener, addPropertyChangeListener, addWindowFocusListener, addWindowListener, addWindowStateListener, applyResourceBundle, applyResourceBundle, createBufferStrategy, createBufferStrategy, dispose, getBackground, getBufferStrategy, getFocusableWindowState, getFocusCycleRootAncestor, getFocusOwner, getFocusTraversalKeys, getIconImages, getInputContext, getListeners, getLocale, getModalExclusionType, getMostRecentFocusOwner, getOpacity, getOwnedWindows, getOwner, getOwnerlessWindows, getShape, getToolkit, getType, getWarningString, getWindowFocusListeners, getWindowListeners, getWindows, getWindowStateListeners, hide, isActive, isAlwaysOnTop, isAlwaysOnTopSupported, isAutoRequestFocus, isFocusableWindow, isFocusCycleRoot, isFocused, isLocationByPlatform, isOpaque, isShowing, isValidateRoot, pack, paint, postEvent, processEvent, processWindowFocusEvent, processWindowStateEvent, removeWindowFocusListener, removeWindowListener, removeWindowStateListener, reshape, setAlwaysOnTop, setAutoRequestFocus, setBounds, setBounds, setCursor, setFocusableWindowState, setFocusCycleRoot, setIconImages, setLocation, setLocation, setLocationByPlatform, setLocationRelativeTo, setMinimumSize, setModalExclusionType, setSize, setSize, setType, setVisible, show, toBack, toFront`

### Methods inherited from class java.awt.Container

`add, add, add, add, add, addContainerListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getAlignmentX, getAlignmentY, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalPolicy, getInsets, getLayout, getMaximumSize, getMinimumSize, getMousePosition, getPreferredSize, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, print, printComponents, processContainerEvent, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusTraversalKeys, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setFont, transferFocusDownCycle, validate, validateTree`

### Methods inherited from class java.awt.Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, contains, createImage, createImage, createVolatileImage, createVolatileImage, disable, disableEvents, dispatchEvent, enable, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBaseline, getBaselineResizeBehavior, getBounds, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphicsConfiguration, getHeight, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocation, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getSize, getTreeLock, getWidth, getX, getY, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isDoubleBuffered, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, prepareImage, prepareImage, printAll, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processKeyEvent, processMouseEvent, processMouseMotionEvent, processMouseWheelEvent, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resize, resize, revalidate, setComponentOrientation, setDropTarget, setEnabled, setFocusable, setFocusTraversalKeysEnabled, setForeground, setIgnoreRepaint, setLocale, setMaximumSize, setName, setPreferredSize, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface java.awt.MenuContainer

`getFont, postEvent`

### Constructor Detail

#### Parameter_View

    public Parameter_View(String title,
                  Parameter parameter)

Creates a Parameter_View from the specified Parameter.

Parameters:
  `parameter` - The Parameter to be displayed.

#### Parameter_View

    public Parameter_View(Parameter parameter)

Creates a Parameter_View from the specified Parameter and gives it the Parameter's name as the title.

Parameters:
  `parameter` - The Parameter to be displayed.

### Method Detail

#### Parameter_Pane

    public Parameter_Pane Parameter_Pane()

Gets the Parameter_Pane used by this Parameter_View.

Returns:
  The Parameter_Pane used by this Parameter_View.

#### Parameter

    public Parameter Parameter()

Gets the Parameter being viewed by this Parameter_View.

Returns:
  The Parameter viewed by this Parameter_View.

#### Parameter

    public void Parameter(Parameter parameter)

Sets the Parameter to be viewed by this Parameter_View.

Parameters:
  `parameter` - The Parameter to be viewed by this Parameter_View.
See Also:
  `Parameter_Pane.Parameter(Parameter)`

#### TreeTable

    public JTreeTable TreeTable()

Gets the JTreeTable being used to represent the Parameters in the display.

Returns:
  The JTreeTable representing this Parameter_View.

#### CWD

    public String CWD()

Gets the current working directory for finding parameter files.

#### CWD

    public Parameter_View CWD(String pathname)
                       throws FileNotFoundException

Sets the current working directory for finding parameter files.

Parameters:
  `pathname` - A host filesystem pathname. If null, the "user.dir" System property will be used.
Returns:
  This Parameter_View.
Throws:
  `FileNotFoundException` - If neither the file nor the file's parent refers to an existing directory.
See Also:
  `CWD(File)`

#### CWD

    public Parameter_View CWD(File file)
                       throws FileNotFoundException

Sets the current working directory for finding parameter files.

Parameters:
  `file` - A File to which to set the CWD. If null, the "user.dir" System property will be used. If the file does not refer to an existing directory, the file's parent will be used.
Returns:
  This Parameter_View.
Throws:
  `FileNotFoundException` - If neither the file nor the file's parent refers to an existing directory.

#### Use_LAF_Hack

    public static boolean Use_LAF_Hack()

Tests if the Java (cross platform) Look and Feel is to be used.

As of Java 1.4 the native Look and Feel for Apple OS X does not function properly with the JTreeTable. The Java Look and Feel does not have this problem. Thus this hack to force its use.

Returns:
  true if the Java Look and Feel hack will be used; false otherwise.

#### Use_LAF_Hack

    public static void Use_LAF_Hack(boolean enable)

Enables or disables the Java (cross platform) Look and Feel hack.

As of Java 1.4 the native Look and Feel for Apple Mac OS X does not function properly with the JTreeTable used to display Parameters and their Values. The Java Look and Feel does not have this problem. Thus this hack to force its use. If the hack is disabled the hack will not be used.

This hack is enabled by default if the "os.name" system property is "Mac OS X"; otherwise it is disabled.

Parameters:
  `enable` - true if the Look and Feel hack is to be used; false otherwise.

#### Title

    public Parameter_View Title(String source)

Sets the window title to the filename portion of the name.

The source may be a file pathname or URL reference. The filename portion of either will be used as the window title.

Parameters:
  `source` - The source reference from which to obtain the filename. If null the tile will be blank.
Returns:
  This Parameter_View.

#### Title

    public Parameter_View Title(URL url)

Sets the window title to the filename portion of the URL.

Parameters:
  `url` - The URL from which to obtain the filename. If null the tile will be blank.
Returns:
  This Parameter_View.

#### Menu_Bar

    protected JMenuBar Menu_Bar()

Creates a menu bar for the viewer.

File
New
  A JFileChooser is used to select a another file for display of its PVL parameters with a new Parameter_View. The JFileChooser directory is initially the user.dir System property, but it is reset after each file is opened to the directory that contained that file.
Open
  A JFileChooser is used to select a another file for display of its PVL parameters in the current Parameter_View.
Close
  Will cause the current window to close. If being run from main and this is the last window the application will exit.
Exit
  Will cause the application to exit.

Returns:
  The viewer's JMenuBar.

#### main

    public static void main(String[] arguments)

Creates a Parameter_View displaying the Parameters found in each file listed on the command line.

Parameters:
  `arguments` - The command line arguments String array. If no arguments are provided an empty viewer will be created.